#pragma hdrfile fileinfo.csm
#include <windows.h>
#include <process.h>
#include <debug.h>
#include <string>
#pragma hdrstop
#include "listbox.h"
#include "system.h"
#include "globals.h"

extern "C"
{
    BOOL WINAPI DllMain( HINSTANCE hinstDLL, // handle of DLL module
                     DWORD dwReason,     // reason for calling function
                     LPVOID pvReserved   // reserved
                     );
};

#if 0
BOOL WINAPI Handler( DWORD dwCtrlType );

BOOL WINAPI Handler( DWORD dwCtrlType )
{
    if( dwCtrlType == CTRL_CLOSE_EVENT )
    {
        g_pListBox->ExitTSE( true );
        return true;
    }
    return false;
}
#endif

BOOL WINAPI DllMain( HINSTANCE hinstDLL, // handle of DLL module
                     DWORD dwReason,     // reason for calling function
                     LPVOID pvReserved   // reserved
                     )
{
    switch( dwReason )
    {
        case DLL_PROCESS_ATTACH:
            TRACE( "Attaching DLL" );

// removed closing of TSE by grabbing CTRL_CLOSE_EVENT
// as it popped up the End task / Wait / Cancel box
// which we have no control over (well, we can eliminate the box
// and have the process die automatically, but this is not what we want)
#if 0
            if( !SetConsoleCtrlHandler( Handler, true ) )
            {
                TRACE( "Error setting handler: " << GetLastError() );
            }
#endif
            break;

        case DLL_PROCESS_DETACH:
            TRACE( "Detaching DLL" );
            delete g_pListBox;

            if( g_hSem )
            {
                ::ReleaseSemaphore( g_hSem, 1, 0 );
                CloseHandle( g_hSem );
            }
            break;
    }

    return true;
}


void GuiThread( void* pData )
{
    g_pListBox->Create();

    // signal that window creation is finished - we are now entering
    // the main message loop.
    SetEvent( (HANDLE)pData );
    CloseHandle( (HANDLE) pData );      // done with this event structure

    MSG msg;
    while( GetMessage( &msg, 0, 0, 0 ))
    {
        TranslateMessage( &msg );
        DispatchMessage( &msg );
    }
}

BOOL TrayMessage( HWND hwnd, DWORD dwMessage, UINT uID, HICON hIcon, PSTR pszTip)
{
    BOOL res;

    NOTIFYICONDATA tnd;

    tnd.cbSize      = sizeof(NOTIFYICONDATA);
    tnd.hWnd        = hwnd;
    tnd.uID         = uID;

    tnd.uFlags      = NIF_MESSAGE | NIF_ICON | NIF_TIP;
    tnd.uCallbackMessage = MYWM_NOTIFYICON;
    tnd.hIcon       = hIcon;
    if( pszTip )
    {
        lstrcpyn(tnd.szTip, pszTip, sizeof(tnd.szTip));
    }
    else
    {
        tnd.szTip[ 0 ] = '\0';
    }

    res = Shell_NotifyIcon( dwMessage, &tnd );

    if (hIcon)
    {
        DestroyIcon(hIcon);
    }

    return res;
}
